﻿#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <iomanip>
#include <vector>
#include <cstdint>
#include <set>
#include <map>

#define int long long
#define vec vector
#define all(a) a.begin(), a.end()

using namespace std;

void solve() {
    int n; cin >> n;
    int k; cin >> k;
    int prevk = k;
    map<int, int> mp;
    mp[n] = 1;
    while (1) {
        int xx = (*mp.rbegin()).first;
        int v1 = xx / 2;
        int v2 = xx / 2 + (xx % 2);
        if (k >= mp[xx]) {
            mp[v1] += mp[xx];
            mp[v2] += mp[xx];
            k -= mp[xx];
            mp.erase(mp.find(xx));
            continue;
        }
        mp[xx] -= k;
        mp[v1] += k;
        mp[v2] += k;
        break;
    }
    int q; cin >> q;
    for (int i = 0; i < q; i++) {
        int x; cin >> x;
        //size - k + 1
        x = prevk + 1 - x;
        for (auto& e : mp) {
            if (e.second > x) {
                cout << e.first << ' ';
                break;
            }
            x -= e.second;
        }
    }
}

int32_t main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}