#define _USE_MATH_DEFINES

#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

#define endl "\n";

template<typename T>
istream& operator>>(istream& in, vector<T>& arr_) {
    for (auto& i_ : arr_) {
        in >> i_;
    }
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T>& arr_) {
    for (auto& i_ : arr_) {
        out << i_ << " ";
    }
    return out;
}


using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using str = string;

#define fast cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0)
#define p_b push_back()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define int ll

signed main() {
    fast;

    ll L, R;
    cin >> L >> R;
    int n;
    cin >> n;
    vector<int> d(n);
    cin >> d;

    vector<ll> pref_sm(n + 1);
    pref_sm[0] = 0;
    for (int i = 1; i <= n; i++) {
        pref_sm[i] = pref_sm[i - 1] + d[i - 1];
    }

    ll s = -1, f = -1;
    for (int i = 0; i <= n; i++) {
        int ind = lower_bound(all(pref_sm), L + pref_sm[i]) - pref_sm.begin();
        if (ind > n || pref_sm[ind] - pref_sm[i] > R) {
            continue;
        }
        int new_s = pref_sm[i], new_f = pref_sm[ind];
        if (s == -1) {
            s = new_s, f = new_f;
        }
        else if (new_f < f) {
            s = new_s, f = new_f;
        }
        else if (new_f == f && new_s < s) {
            s = new_s, f = new_f;
        }
    }

    cout << s << " " << f;
}