L, R = map(int, input().split())
n = int(input())
distances = list(map(int, input().split()))

s = -1
t = -1

prefix_sum = [0] * (n + 1)
for i in range(1, n + 1):
    prefix_sum[i] = prefix_sum[i - 1] + distances[i - 1]

for start in range(n + 1):
    for end in range(start, n + 1):
        total_distance = prefix_sum[end] - prefix_sum[start]
        if total_distance >= L and total_distance <= R:
            if start == 0 or end == n or distances[start - 1] != distances[end]:
                s = prefix_sum[start]
                t = prefix_sum[end]
                break
    if s != -1 and t != -1:
        break

if s == -1 or t == -1:
    print(-1, -1)
else:
    print(s, t)
