from numpy import float64, append, array

L, R = map(float64, input().split())
n = int(input())
trees = list(map(float64, input().split()))
trees_prefix = array([0, trees[0]])
for i in range(1, n):
    trees_prefix = append(trees_prefix, trees[i] + trees_prefix[i])

variants = []
for start in range(n + 1):
    if trees_prefix[-1] - trees_prefix[start] < L:
        break
    else:
        for end in range(start + 1, n + 1):
            if trees_prefix[end] - trees_prefix[start] > R:
                break
            elif L <= trees_prefix[end] - trees_prefix[start]:
                variants.append([start, end])

variants.sort()
print(-1, -1) if len(variants) == 0 else print(int(trees_prefix[variants[0][0]]), int(trees_prefix[variants[0][1]]))
