def cut_rope(n, k, q, queries):
    lengths = [n]

    for _ in range(k):
        max_length = lengths.pop(0)
        if max_length % 2 == 0:
            lengths.extend([max_length // 2] * 2)
        else:
            lengths.extend([max_length // 2, max_length // 2 + 1])

    lengths.sort(reverse=True)

    result = [lengths[i - 1] for i in queries]
    return result

n = int(input())
k = int(input())
q = int(input())
queries = list(map(int, input().split()))  

result = cut_rope(n, k, q, queries)
result_str = ' '.join(map(str, result))  
print(result_str)
