#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    int n, k, q;
    std::cin >> n >> k >> q;
    std::vector<int> tl(q);
    for (int i = 0; i < q; i++) {
        std::cin >> tl[i];
    }

    std::vector<int> nums(n, 0);
    for (int i = 0; i < k; i++) {
        auto max_it = std::max_element(nums.begin(), nums.end());
        int mm = *max_it;
        *max_it = mm / 2;
        nums.push_back(mm - mm / 2);
    }

    std::sort(nums.begin(), nums.end(), std::greater<int>());

    std::vector<int> out;
    for (int t : tl) {
        out.push_back(nums[t - 1]);
    }

    for (int i = 0; i < q; i++) {
        std::cout << out[i] << " ";
    }
    std::cout << std::endl;

    return 0;
}
