#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    long long l, r, n;
    cin >> l >> r >> n;
    vector<long long> dists(n);
    cin >> dists[0];
    for (int i = 1; i < n; ++i) {
        cin >> dists[i];
        dists[i] += dists[i - 1];
    }

    int p2 = 0;
    for (int p1 = 0; p1 < n; ++p1) {
        while (p2 + 1 < n and dists[p2] - dists[p1] < l) {
            ++p2;
        }
        if (dists[p2] - dists[p1] <= r) {
            cout << dists[p1] << ' ' << dists[p2];
            return 0;
        }
    }

    cout << "-1 -1";

    return 0;
}
