#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    long long r, l = 0ll;
    cin >> l >> r;
    long long n = 0;
    cin >> n;


    vector<long long> trees = vector<long long>();
    for(long long i = 0; i<n; i++){
        long long d = 0;
        cin>>d;
        trees.push_back(d);
    }

    vector<long long> prefix = vector<long long>(n);
    prefix[0]=trees[0];
    for(long long i = 1; i<n; i++){

        prefix[i]=prefix[i-1]+trees[i];
    }

    for(long long i = 1; i<=n; i++){
        long long endd = 0;
        endd=prefix[i-1];

        if(endd >= l && endd <= r){
            cout << 0 << ' ' << endd;
            return 0;
        }
        auto ans = lower_bound(prefix.begin(), prefix.begin()+i-1, endd-r);
        if(endd-*ans <= r && endd-*ans >= l){
            cout << *ans << ' ' << endd;
            return 0;
        }
    }
    cout << -1 << ' ' << -1;
    return 0;
}
