def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num ** 0.5) + 1):
        if num % i == 0:
            return False
    return True

def find_partitions(n, current_sum, primes, partition):
    if current_sum == n and len(primes) > 0:
        print("+".join(map(str, partition)))
        return
    elif current_sum > n:
        return
    else:
        start = 2
        if len(primes) > 0:
            start = primes[-1]
        for i in range(start, n + 1):
            if is_prime(i):
                find_partitions(n, current_sum + i, primes + [i], partition + [i])

n = int(input())
find_partitions(n, 0, [], [])