def count_divisors(num):
    divisors = 1
    i = 2
    while i * i <= num:
        power = 0
        while num % i == 0:
            power += 1
            num //= i
        divisors *= (power + 1)
        i += 1
    if num > 1:
        divisors *= 2
    return divisors

def count_nontrivial_decompositions(n):
    p1 = n ** 0.5
    p2 = n // p1
    if p1 * p2 == n:
        return count_divisors(p1) * count_divisors(p2)
    else:
        return 0

n = int(input("Введите число n: "))
result = count_nontrivial_decompositions(n)
print(result)
