def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return False
    return True

def generate_nonprime_partitions(n, current_partition):
    if n == 0:
        print('+'.join(map(str, current_partition)))
        return

    for i in range(1, n + 1):
        if not is_prime(i):
            new_partition = current_partition + [i]
            generate_nonprime_partitions(n - i, new_partition)

if __name__ == "__main__":
    n = int(input())
    generate_nonprime_partitions(n, [])