n = int(input())
k = int(input())
q = int(input())
queries = list(map(int, input().split()))


def count_ropes(length, ropes):
    count = 0
    for rope in ropes:
        count += rope // length
    return count


low, high = 1, n
result = []

while low < high:
    mid = (low + high + 1) // 2
    if count_ropes(mid, [n] * k) >= k:
        low = mid
    else:
        high = mid - 1

result = [low] * q

print(*result)
