def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return False
    return True


def non_prime_partitions(n, current_partition=[], start=1):
    result = []
    if n == 0:
        result.append('+'.join(map(str, current_partition)))
    for i in range(start, n + 1):
        if not is_prime(i):
            result.extend(non_prime_partitions(n - i, current_partition + [i], i))
    return result

for i in non_prime_partitions(int(input())):
    print(i)
