L, R = map(int, input().split())
n = int(input())
distances = list(map(int, input().split()))

# нач значения для начала и конца дистанции
s, t = -1, -1
# поиск возможных комбинц начальной и конечной точек
for i in range(n):
    for j in range(i, n):
        start = distances[i] if i == 0 else 0  # Начало дистанции либо от начала дорожки, либо от дерева
        end = distances[j]  # Конец дистанции около дерева
        
        # Проверка условий длины дистанции
        if L <= end - start <= R:
            # Проверка близости к началу дорожки для конечной точки
            if t == -1 or end < t:
                s, t = start, end
            # Если конечные точки одинаково близки к началу, выбираем ближайшую к началу начальную точку
            elif end == t and start < s:
                s = start

# Вывод результатов
if s == -1:
    print("-1 -1")
else:
    print(s, t)