import math,sys

def is_prime(n):
    if n==2:
        return True
    if n&1==0: return False
    sq = math.ceil(math.sqrt(n))
    for i in range(3,sq):
        if n%i==0:
            return False
    return True

def factor(n):
    assert n>0
    if n==1:return 
    if n&1==0:
        yield 2
        yield from factor(n>>1)
        return
    sq = math.ceil(math.sqrt(n))
    for i in range(3,sq+1):
        if n%i==0:
            n//=i
            yield i
            yield from factor(n)
            return
    if n>1:
        yield n

def factorial(n):
    if n<=1: return n
    return factorial(n-1)*n

def C(n,k):
    return factorial(n)//factorial(n-k)/factorial(k)

def comb(f,fu):
    if len(f)<=2: return f
    cmbs = list()
    for i in range(len(f)):
        for _ in comb(f[:i]+f[i:], fu):
            z= [i]+_
            if z not in cmbs:
                cmbs.append(z)
                yield z

n=int(input())
factors = tuple(factor(n))
factors_df = set(factors)
if len(factors)==1:
    print(0)
    sys.exit(0)
if len(factors)==2:
    print(1)
    sys.exit(0)
if len(factors_df)==1:
    print(len(factors))
    sys.exit(0)

 


    
