def partition(n, start, prev):
    if n == 0:
        output = '+'.join(map(str, prev))
        print(output)
        return

    for i in range(start, n + 1):
        if is_prime(i):
            continue
        partition(n - i, i, prev + [i])


def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num ** 0.5) + 1):
        if num % i == 0:
            return False
    return True


n = int(input("Введите число n: "))
partition(n, 1, [])
