import dis
import math
import re


def dist_to_center(n):
    if n % 2 == 0:
        return abs(n / 2)
    else:
        c = math.ceil(n / 2)
        return abs(c)


n, k = int(input()), int(input())

arr = [["."] * n for _ in range(n)]


for i in range(1,n+1):
    for j in range(1,n+1):

        if dist_to_center(n) - math.floor(k/2) <= i <= dist_to_center(n) + math.floor(k/2):
            arr[i-1][j-1] = "*"

        if dist_to_center(n) - math.floor(k/2) <= j <= dist_to_center(n) + math.floor(k/2):
            arr[i-1][j-1] = "*"

for i in range(n):
    for j in range(n):
        print(arr[i][j], end="")
    print()
