﻿#include <iostream>
#include <cmath>
#include <vector>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    long long a, b;
    cin >> a >> b;

    long long n;
    cin >> n;
    vector<long long> trees(n + 1, 0);
    for (long long i = 1; i <= n; i++) {
        cin >> trees[i];
    }
    for (long long i = 1; i < n; i++) {
        trees[i] += trees[i - 1];
    }


    vector<vector<long long>> var(0, vector<long long>(0));
    for (long long i = 0; i < n + 1; i++) {
        for (long long j = i + 1; j < n + 1; j++) {
            if ((trees[j] - trees[i]) >= a && (trees[j] - trees[i]) <= b) {
                cout << trees[i] << ' ' << trees[j];
                return 0;
            }
        }
    }
    cout << "-1 -1";
    return 0;
}