#include <iostream>
#include <vector>

int triangle(int a, int b, int c)
{
	if (a + b <= c)
		return 0;
	if (a + c <= b)
		return 0;
	if (c + b <= a)
		return 0;
	return 1;
}

int squre(int a, int b, int c)
{
	int p = (a + b + c) / 2;
	int k = (p - a) * (p - b) * (p - c);
	if (k >= 0)
		return 1;
	return 0;
}

int main(void)
{
	int a, b;

	std::cin >> a;
	std::cin >> b;

	if (a < 0 || b < 0)
		return 0;
	int k = 0;
	for (int i = 0; i < 1000000; i++)
	{
		if (triangle(a, b, i) && squre(a, b, i))
		{
			k++;
		}
	}
	std::cout << k;
}