#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <iterator>
#include <bitset>
#include <cstdlib>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <random>

using namespace std;

long long pow1(long long a, long long p) {
    long long res = 1;
    for (; p > 0; p >>= 1) {
        if (p & 1) {
            res *= a;
        }
        a *= a;
    }
    return res;
}

long long p = -1, q = -1, k;

 int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    long long n;
    cin >> n;
    long long copy_n = n;
    k = 0;
    for (long long i = 2; i * i <= n; i++) {
        if (n % i == 0) {
            if (p == -1) {
                p = i;
            } else {
                q = i;
            }
        }
        while (n % i == 0) {
            if (q == -1) {
                k++;
            }
            n /= i;
        }
    }
    if (q == -1) {
        q = n;
    }
//    cout << p << " " << q << '\n';
//    k = (log2(copy_n) / log2(p * q));
    map<long long, map<long long, long long>> dp;
    for (long long i = 0; i <= k; i++) {
        for (long long j = 0; j <= k; j++) {
            dp[1][pow1(p, i) * pow1(q, j)] = 1;
        }
    }
    for (long long i = 0; i <= k; i++) {
        for (long long j = 1; j <= k; j++) {
            for (long long i1 = 0; i1 <= k; i1++) {
                for (long long j1 = 0; j1 <= k; j1++) {
                    //dp[ij][i1j1]
                    long long m = pow1(p, i1) * pow1(q, j1);
                    long long cur = pow1(p, i) * pow1(q, j);
                    for (long long i2 = 0; i2 <= k; i2++) {
                        for (long long j2 = 0; j2 <= k; j2++) {
                            if (pow1(p, i2) * pow1(q, j2) >= m && i2 <= i && j2 <= j) {
                                dp[cur][m] += dp[cur / (pow1(p, i2) * pow1(q, j2))][pow1(p, i2) * pow1(q, j2)];
                            }
                        }
                    }
//                    cout << "cur: " << cur << "    m: " << m << '\n';
//                    cout << dp[cur][m] << '\n';
                }
            }
        }
    }
    long long res = 0;
    res += dp[copy_n][1] - 1;
    cout << res;
    return 0;
}