#include <iostream>
#include <vector>

int main( void )
{
  int l, r, n;
  std::cin >> l >> r >> n;

  std::vector<int> dist(n + 1);
  dist[0] = 0;
  for (int i = 1; i < n; i++)
    std::cin >> dist[i], dist[i] += dist[i - 1];

  int tmp;
  for (int i = 0; i < n; i++)
    for (int j = i + 1; j < n; j++)
    {
      tmp = dist[j] - dist[i];
      if (tmp > r)
        break;
      if (tmp > l)
      {
        std::cout << dist[i] << ' ' << dist[j];
        return 0;
      }
    }

  std::cout << "-1 -1";
  return 0;
}