#include <iostream>
#include <vector>
#include <cmath>
#include <string>

using namespace std;

void erat(vector <int>& erat)
{
	for (int i = 70; i >= 1; --i)
		for (int j = 2; j < i + 2; ++j)
		{
			if (i % j == 0 && i != j)
			{
				erat.push_back(i);
				break;
			}
		}
}

string tostr(int a)
{
	string s = "";
	while (a != 0)
	{
		s = char(a % 10 + 48) + s;
		a = a / 10;
	}
	return s;
}

void solve(int n, vector <int> er, int level, vector <int> s)
{
	if (n == 0)
	{
		cout << s[s.size() - 1];
		for (int i = 2; i < s.size() + 1; ++i)
			cout << "+" << s[s.size() - i];
		cout << '\n';
		return;
	}
	for (int i = level; i < er.size(); ++i)
	{
		if (n - er[i] >= 0)
		{
			vector <int> q = s;
			s.push_back(er[i]);
			solve(n - er[i], er, i, s);
			s = q;
		}
	}
}

int main()
{
	int n;
	cin >> n;
	vector <int> er;
	erat(er);
	er.push_back(1);
	vector <int> s;
	solve(n, er, 0, s);
}