#include <iostream>
#include <map>
#include <vector>

using namespace std;

#define ll long long

map<ll, ll> M;

ll get_max() {
  auto x = M.end();
  x--;
  return x->first;
}

ll min(ll a, ll b) {
  if (a < b) { return a; }
  return b;
}

int main() {
  ll n, k, q;
  cin >> n >> k >> q;
  
  M[n] = 1;
  while (k != 0) {
    ll x = get_max();
    ll del_cnt = min(M[x], k);
    if (del_cnt == M[x]) {
      auto e = M.end();
      e--;
      M.erase(e);
      k -= del_cnt;
    }
    else {
      k -= del_cnt;
      M[x] -= del_cnt;
    }

    if (x % 2 == 0) {
      M[x / 2] += del_cnt * 2;
    }
    else {
      M[x / 2] += del_cnt;
      M[x / 2 + 1] += del_cnt;
    }
  }
  
  struct node {
    ll number;
    ll cnt;
  };
  vector<node> L;
  L.resize(M.size());
  ll j = L.size() - 1;
  for (auto i : M) {
    L[j] = { i.first, i.second };
    j--;
  }
  
  //for (auto e : L) {
  //  cout << e.number << ' ' << e.cnt << '\n';
  //}

  ll i;
  for (ll z = 0; z < q; z++) {
    cin >> i;
    int j = 0;
    while (true) {
      if (L[j].cnt >= i) {
        cout << L[j].number << ' ';
        break;
      }
      i -= L[j].cnt;
      j++;
    }    
  }
}