#include <iostream>
#include <vector>
#include <stdint.h>
using namespace std;

int main()
{
	//Read L and R
	uint64_t l, r;
	cin >> l >> r;

	//Read N
	uint16_t n;
	cin >> n;

	//Read vector
	vector<uint64_t> d(n);
	for (uint32_t i = 0; i < n; i++)
	{
		cin >> d[i];
	}

	uint64_t sum = 0;
	uint64_t start = 0;
	uint64_t end = 0;

	bool is_find = false;

	for (uint16_t i = 0; i < n; i++)
	{
		start = i;
		sum = 0;

		for (uint16_t j = i; j < n; j++)
		{
			sum += d[j];

			if (sum >= l && sum <= r)
			{
				end = j;
				is_find = true;
				break;
			}

			if (sum >= r)
			{
				break;
			}
		}

		if (is_find)
		{
			start = i;
			break;
		}
	}

	if (!is_find)
	{
		cout << -1 << " " << -1;
	}
	else
	{
		uint64_t start_sum = 0;
		for (uint64_t i = 0; i < start; i++)
		{
			start_sum += d[i];
		}

		uint64_t end_sum = 0;
		for (uint64_t j = 0; j <= end; j++)
		{
			end_sum += d[j];
		}

		cout << start_sum << " " << end_sum;
	}

	return 0;
}