#include <iostream>
#include <vector>
using namespace std;

int main()
{
    long long int l, r;
    cin >> l >> r;
    int n;
    cin >> n;
    vector <long long int> dist;
    dist.push_back(0);
    for (int i = 1; i <= n; ++i) {
        long long int d;
        cin >> d;
        d += dist[i - 1];
        dist.push_back(d);
    }
    int index_l = 0;
    int index_r = 1;
    while (index_l <= index_r && index_r <= n && index_l <= n) {
        long long int distance = dist[index_r] - dist[index_l];
        if (distance >= l && distance <= r) {
            cout << dist[index_l] << ' ' << dist[index_r];
            return 0;
        }
        else if (distance < l) ++index_r;
        else if (distance > r) ++index_l;
    }
    cout << -1 << ' ' << -1;
    return 0;
}
