def road_crossing(n, l):
half = n // 2
char = ‘*’ if n % 2 == 0 else ’ ’ # символ для клеток дороги/вне дороги
block = char * l # блок из l символов

upper_left = block[:l]  # верхняя левая часть перекрестка
lower_left = upper_left.center(half * 2, char)  # нижняя левая часть перекрестка
upper_right = lower_left[half:]  # верхняя правая часть перекрестка
lower_right = upper_right.ljust(n, char)  # нижняя правая часть перекрестка

crossing = upper_left + lower_right + upper_right + lower_left
for _ in range(half - l):  # рисуем горизонтальные линии
    crossing += '\n' + half * ' '

return crossing
n = int(input()) # размер перекрестка
l = int(input()) # ширина дороги

print(road_crossing(n, l)) # вывод перекрестка