def count_factorizations(n):
    # Функция для нахождения простых множителей числа
    def prime_factors(num):
        factors = []
        divisor = 2
        while divisor <= num:
            if num % divisor == 0:
                factors.append(divisor)
                num = num // divisor
            else:
                divisor += 1
        return factors

    # Находим простые множители числа n в степени k
    prime_factors_n = prime_factors(n)

    # Считаем количество различных нетривиальных разложений
    result = 1
    for factor in set(prime_factors_n):
        # Количество различных разложений для каждого простого множителя
        exponent_count = prime_factors_n.count(factor)
        result *= (2 * exponent_count + 1)

    return result