from math import sqrt

def is_prime(num):
    if num == 1:
        return False
    elif num == 2:
        return True
    else:
        for i in range(2, int(sqrt(num)) + 1):
            if num % i == 0:
                return False
        return True

def generate_partitions(n):
    if n == 1:
        return ['1']
    elif n == 2:
        return ['1+1']
    elif n == 3:
        return ['1+1+1']
    else:
        partitions = []
        for i in range(1, n + 1):
            if not is_prime(i):
                for partition in generate_partitions(n - i):
                    partitions.append(str(i) + '+' + partition)
        return partitions

n = int(input())
partitions = generate_partitions(n)

for partition in partitions:
    print(partition)