from functools import lru_cache

unprime = [1, 4, 6, 8, 9, 10, 12, 14, 15, 16, 18, 20, 21, 22, 24, 25, 26, 27, 28, 30, 32, 33, 34, 35, 36, 38, 39, 40,
           42, 44, 45, 46, 48, 49, 50, 51, 52, 54, 55, 56, 57, 58, 60, 62, 63, 64, 65, 66, 68, 69, 70]

is_prime = [True, False, True, True, False, True, False, True, False, False, False, True, False, True, False, False,
            False, True, False, True, False, False, False, True, False, False, False, False, False, True, False, True,
            False, False, False, False, False, True, False, False, False, True, False, True, False, False, False, True,
            False, False, False, False, False, True, False, False, False, False, False, True, False, True, False, False,
            False, False, False, True, False]


@lru_cache
def factor(n):
    if n == 1:
        return [(1,)]
    if n < 1:
        return []
    res = []
    if not is_prime[n]:
        res.append([n])
    for i in unprime:
        if i > n:
            break
        res += (tuple(sorted((i, ) + j)) for j in factor(n - i))
        if not is_prime[n - i]:
            res.append(tuple(sorted((i, n - i))))
    return set(res)

n = int(input())

for i in factor(n):
    print('+'.join(str(j) for j in i))
