def cut_rope(n, k, queries):
    ropes = [n]
    for _ in range(k):
        ropes.sort(reverse=True)
        max_rope = ropes.pop(0)
        if max_rope % 2 == 0:
            ropes.extend([max_rope // 2, max_rope // 2])
        else:
            ropes.extend([max_rope // 2, max_rope // 2 + 1])
    
    ropes.sort(reverse=True)
    results = [ropes[min(t, len(ropes) - 1)] for t in queries]
    return results

# Пример использования:
n = 100
k = 5
q = 6
queries = [1, 2, 3, 4, 5, 6]

result = cut_rope(n, k, queries)
print(result)
