#include <iostream>
#include <vector>
using namespace std;

vector <int> eratosphen(vector <bool>& prime, int n) {
	vector <int> pr = {1};
	for (int i = 2; i < n; i++) {
		if (prime[i]) {
			for (int j = i * i; j < n; j += i) {
				prime[j] = false;
				pr.push_back(j);
			}
		}
	}
	return pr;
}

void cnt(int now, vector <int>& s, vector <int> &prime) {
	if (!now) {
		int t = (int)s.size();
		for (int i = 0; i < t; i++) {
			if (i != t - 1)
				cout << s[i] << '+';
			else
				cout << s[i] << endl;
		}
		return;
	}
	for (auto i : prime) {
		if (s.size() == 0 && i < now) {
			s.push_back(i);
			cnt(now - i, s, prime);
			s.pop_back();
		}
		else if (i <= now && i >= s.back()) {
			s.push_back(i);
			cnt(now - i, s, prime);
			s.pop_back();
		}
	}
}

int main()
{
	int n;
	cin >> n;
	vector <bool> erat(n, true);
	vector <int> prime = eratosphen(erat, n), s;
	cnt(n, s, prime);
	bool flag = true;
	for (int i = 2; i < n; i++) {
		if (n % i == 0) {
			bool flag = false;
			break;
		}
	}
	if (flag)
		cout << n;
}