L, R = map(int, input().split())
n = int(input())
distances = list(int(x) for x in input().split())
runs = []

for start_i in range(0, n - 1):
    start = sum(distances[:start_i])
    finish = sum(distances[:start_i + 1])
    finish_i = start_i

    while finish - start < L and finish_i + 1 < n:
        finish_i += 1
        finish += distances[finish_i]

    if L <= finish - start <= R:
        runs.append((start, finish))

#  1 2 3 4 5
# | | | | | |

if not runs:
    print("-1 -1")
    exit()

# Too much filtering
# why not?
min_finish = min(run[1] for run in runs)
runs = [run for run in runs if run[1] == min_finish]

min_start = min(run[0] for run in runs)
runs = [run for run in runs if run[0] == min_start]

print(*runs[0])
