﻿#include <iostream>
#include <vector>

using namespace std;

int n;

bool is_prime(int x) {
    if (x == 1) {
        return false;
    }

    for (int g = 2; g * g <= x; ++g) {
        if (x % g == 0) {
            return false;
        }
    }

    return true;
}

void func(int cnt, int x, vector<int> &a) {
    if (cnt < 0) {
        return;
    } 

    if (cnt != 0) {
        for (int i = x; i <= n; ++i) {
            if (!is_prime(i)) {
                a.push_back(i);
                func(cnt - i, i, a);
                a.pop_back();
            }
        }
    }
    else {
        cout << a[0];
        for (int i = 1; i < a.size(); ++i) {
            cout << "+" << a[i];
        }
        cout << "\n";
        return;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        if (!is_prime(i)) {
            vector<int> a = { i };
            func(n - i, i, a);
        }
    }
    return 0;
}

