#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using lll = __int128;

void cut(priority_queue<ll>& cur_ropes, ll left) {
    while (left > 0) {
        ll cur_elem = cur_ropes.top();
        cur_ropes.pop();
        if (cur_elem % 2 == 0) {
            cur_ropes.push(cur_elem / 2);
            cur_ropes.push(cur_elem / 2);
        } else {
            cur_ropes.push(ceil(cur_elem / 2.0));
            cur_ropes.push(floor(cur_elem / 2.0));
        }
        left--;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    ull n, k, q;
    cin >> n >> k >> q;
    priority_queue<ll> arr;
    vector<ll> operations;
    operations.reserve(q);
    for (ll i = 0; i < q; i++) {
        ll num;
        cin >> num;
        operations.push_back(num);
    }
    arr.push(n);
    cut(arr, k);
    ll cur_ropes_size = arr.size();
    vector<ll> nums(cur_ropes_size);
    for (ll i = 0; i < cur_ropes_size; i++) {
        nums[i] = arr.top();
        arr.pop();
    }
    for (ll i = 0; i < q; i++) {
        cout << nums[operations[i] - 1] << "\n";
    }
}