#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using ull = unsigned long long;

ull step = 0;
ull ans = 0;
vector<ll> step1, step2;

void func(ull x, vector<ull> ls, ull si, ull d, ull c) {
    for (ull n = 0; n <= step; n++) {
        if (x % step1[n] != 0) {
            break;
        }
        ull e = 0;
        if (n <= d) {
            e = c;
        }
        for (ull m = e; m <= step; m++) {
            if (x % step2[m] != 0) {
                break;
            }
            if ((n != 0 || m != 0) && (n != step || m != step)) {
                ull p = step1[n] * step2[m];
                ull r;
                if (si != 0) {
                    r = ls[si - 1];
                }
                if (si == 0 || p >= r){
                    if (x == p) {
                        ans++;
                        break;
                    }
                    ls.push_back(p);
                    func(x / p, ls, si + 1, n, m);
                    ls.pop_back();
                }
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ull n;
    cin >> n;
    ull t = n;
    ull i = 2;
    pair<ull, ull> del = make_pair(0, 0);
    while (i * i <= n) {
        if (n % i == 0) {
            if (del.first == 0) {
                del.first = i;
            } else {
                del.second = i;
            }
            while (n % i == 0) {
                n /= i;
                if (i == del.first) {
                    step++;
                }
            }
        }
        i++;
        if (i % 2 == 0) {
            i++;
        }
    }
    if (n != 1) {
        del.second = n;
    }
    step1.resize(step + 1);
    step1[0] = 1;
    step2.resize(step + 1);
    step2[0] = 1;
    for (ll i = 1; i <= step; i++) {
        step1[i] = step1[i - 1] * del.first;
        step2[i] = step2[i - 1] * del.second;
    }
    if (step == 1) {
        cout << 1;
        return 0;
    }
    vector<ull> p(0);
    func(t, p, 0, 0, 0);
    cout << ans;
}