#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>

using ll = long long;
using ld = long double;

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int n, l;
    cin >> n >> l;

    int halfN = n / 2;
    int halfL = l / 2;
    vector<vector<char>> table(n, vector<char>(n, '.'));
    for (int i = 0; i < n; ++i) {
        for (int j = halfN-halfL; j < halfN-halfL+l; ++j) {
            table[i][j] = '*';
        }
    }


    for (int j = halfN-halfL; j < halfN-halfL+l; ++j) {
        for (int i = 0; i < n; ++i) {
            table[j][i] = '*';
        }
    }

    for (int i=0; i<n; ++i) {
        for (int j =0; j<n; ++j) {
            cout << table[i][j];
        }
        cout << '\n';
    }

    return 0;
}
