#include <iostream>
#include <string>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>

using ll = long long;
using ld = long double;

using namespace std;

const ll inf = 1e18;

string ans;
vector<int> ban;
int rec(int start, int sum) {
    if (sum == 0) {
        cout << ans << '\n';
        return 0;
    }
    for (int nbr = start; nbr < 71; ++nbr) {
        if (sum < nbr) {
            break;
        } else if (ban[nbr]) {
            continue;
        }
        ans += ("+"+to_string(nbr));
        rec(nbr, sum-nbr);
        ans.pop_back();
        ans.pop_back();
    }
    return 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    ban.resize(71);
    vector<int> check = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67};
    for (int& val : check) {
        ban[val] = 1;
    }

    int n;
    cin >> n;

    for (int i = 1; i<=n; ++i) {
        if (ban[i]) {
            continue;
        }
        ans = to_string(i);
        rec(i, n-i);
        ans.pop_back();
    }
}
