#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>

using namespace std;
using ll = long long;

vector<ll> del;
ll ans = 0;

void f(ll n, ll idx) {
    if (n == 1) {
        ans++;
    }
    else {
        for (ll i = idx; i < del.size(); i++) {
            if (n % del[i] == 0) {
                f(n / del[i], i);
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll n, k;
    int q;
    cin >> n >> k >> q;
    vector<ll> ls(n);
    for (int i = 0; i < q; i++) {
        cin >> ls[i];
    }

    multiset<ll> st;
    st.insert(n);
    for (ll i = 0; i < k; i++) {
        auto it = st.end();
        it--;
        ll x = *it;
        st.erase(it);
        st.insert(x / 2);
        st.insert((x + 1) / 2);
    }
    vector<ll> ans(k + 1, 0);
    ll idx = k;
    for (auto i : st) {
//        cout << i << " ";
        ans[idx] = i;
        idx--;
    }
//    cout << endl;
    for (int i = 0; i < q; i++) {
        cout << ans[ls[i] - 1] << " ";
    }
}