#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>

using namespace std;

using ll = long long;

ll n;
vector<ll> sum(n+1);

ll ib(ll x){
    ll l = 0, r = sum.size()-1;
    ll i = r;
    while(l != r && l+1 != r){
        ll t = l + (r-l)/2;
        if(sum[t] >= x){
            r = t;
        }else{
            l = t;
        }
        i = r;
    }
    return i;
}

int main(){
    ll L, R;
    cin >> L >> R;
    cin >> n;
    vector<ll> a(n), sum(n+1);
    sum[0] = 0;
    for(ll i = 0; i < n; i++){
        cin >> a[i];

        sum[i+1] = sum[i] + a[i];
        //cout << sum[i+1] << " ";
    }
    ll j = 0;
    ll ans1 = -1, ans2 = -1;
    while(sum[j] < L){
        j++;
    }
    while(sum[j] <= sum[n] && L <= sum[j]){
        int l1 = sum[j]-L, r1 = sum[j]-R;
        //cout << endl << l1 << " " << r1;
        //cout << endl;
        int x = l1;
        ll l = 0, r = sum.size()-1;
        ll i = r;
        while(l != r && (l+1) != r){
            ll t = l + (r-l)/2;
            if(sum[t] >= x){
                r = t;
            }else{
                l = t;
            }
            //cout << l << " " << r << endl;
            i = r;
        }
        //cout << i << endl;

        int xx = r1;
        ll lll = 0, rr = sum.size()-1;
        ll ii = lll;
        while(lll != rr && (lll+1) != rr){
            ll tt = lll + (rr-lll)/2;
            if(sum[tt] >= xx){
                rr = tt;
            }else{
                lll = tt;
            }
            //cout << lll << " " << rr << endl;
            ii = lll;
        }
        //cout << ii;
        if(i - ii > 1){
            ans1 = sum[ii+1];
            ans2 = sum[j];
            break;
        }
    j++;
    }
    cout << ans1 << " " << ans2;
    return 0;
}
