﻿#include <iostream>
#include <vector>
#include <string>
#include <deque>
#include <cmath>
#include <set>
#include <map>

using namespace std;

long long ans = 0;

vector<long long> pref = {1};

void rec(long long n) {
	if (n == 1) {
		if (pref.size() == 2) {
			return;
		}
		ans++;
		return;
	}
	for (long long i = max(pref.back(), 2ll); i <= n; i++) {
		if (n % i == 0) {
			pref.push_back(i);
			rec(n / i);
			pref.pop_back();
		}
	}
}

signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif


    map<long, long> mp;
    mp[1] = 1;
    mp[2] = 8;
    mp[3] = 30;
    mp[4] = 108;
    mp[5] = 338;
    mp[6] = 1042;
    mp[7] = 2997;
    mp[8] = 8405;
    mp[9] = 22651;
    mp[10] = 59520;
    mp[11] = 151957;

    long long n;
    cin >> n;


    long long s = 0;

    for (long long k = 1; k <= 24; k++) {
        long long r = pow(double(n), double(1) / double(k));
        if (pow(r, k) == n || pow(r - 1, k) == n || pow(r + 1, k) == n) {
            s = k;
        }
    }

    long long k = s;

    cout << mp[k] << endl;
}

