﻿#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <iomanip>
#include <vector>
#include <cstdint>

#define int long long
#define vec vector
#define all(a) a.begin(), a.end()

using namespace std;

vec<bool> isprime(100, 1);
vec<int> cur_ans;

void work(int need, int beg) {
    if (need == 0) {
        int x = cur_ans.back();
        cur_ans.pop_back();
        for (int i : cur_ans) {
            cout << i << '+';
        }
        cout << x << '\n';
        cur_ans.push_back(x);
        return;
    }
    for (int i = beg; i <= need; i++) {
        if (!isprime[i]) {
            cur_ans.push_back(i);
            work(need - i, i);
            cur_ans.pop_back();
        }
    }
}

void solve() {
    int n; cin >> n;
    work(n, 1);
}

int32_t main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    isprime[1] = 0;
    isprime[2] = 1;
    for (int i = 2; i < 100; i++) {
        if (isprime[i]) {
            for (int j = i * i; j < 100; j += i) {
                isprime[j] = 0;
            }
        }
    }
    solve();
    return 0;
}
