﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

#define int long long

using namespace std;

vector<int> good;
vector<string> ans;
int n;

void f(int curr, string s) {
    if (curr == n) {
        ans.push_back(s);
        return;
    }
    for (int num : good) {
        if (curr + num <= n) {
            f(curr + num, s + to_string(num) + "+");
        }
        else {
            break;
        }
    }
}

signed main() {
    cin >> n;
    good.push_back(1);
    for (int i = 1; i <= n; i++) {
        bool ok = true;
        for (int j = 2; j < i; j++) {
            if (i % j == 0) {
                ok = false;
                break;
            }
        }
        if (!ok) {
            good.push_back(i);
        }
    }
    f(0, "");
    set<string> st;
    for (string s : ans) {
        string ss = s;
        sort(ss.begin(), ss.end());
        if (st.find(ss) != st.end()) {
            continue;
        }
        st.insert(ss);
        s.pop_back();
        cout << s;
        cout << '\n';
    }
}
