#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
typedef long long ll;

vector<int> np;

bool isPrime(int a) {
  for (int i = 2; i * i <= a; ++i) {
    if (a % i == 0) return false;
  }
  return true;
}

void fout(vector<int>& ans) {
  for (int i = 0; i < ans.size(); ++i) {
    if (i != ans.size() - 1) {
      cout << ans[i] << "+";
    } else {
      cout << ans[i];
    }
  }
  cout << "\n";
}

void reCursion(int ost, int ind, vector<int>& ans) {
  if (ost == 0) {
    fout(ans);
  }
  for (int i = ind; i < np.size(); ++i) {
    if (ost >= np[i]) {
      ans.push_back(np[i]);
      reCursion(ost - np[i], i, ans);
      ans.pop_back();
    }
  }
}

int main() {
  cin.tie(0);
  cout.tie(0);
  ios_base::sync_with_stdio(false);
  int n;
  cin >> n;
  np.push_back(1);
  for (int i = 1; i <= 70; ++i) {
    if (!isPrime(i)) {
      np.push_back(i);
    }
  }
  vector<int> ans;
  reCursion(n, 0, ans);
  return 0;
}
