#define _USE_MATH_DEFINES

#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

#define endl "\n";

template<typename T>
istream& operator>>(istream& in, vector<T>& arr_) {
	for (auto &i_ : arr_) {
		in >> i_;
	}
	return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T>& arr_) {
	for (auto& i_ : arr_) {
		out << i_ << " ";
	}
	return out;
}


using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using str = string;

#define fast cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0)
#define p_b push_back()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define int ll

int solve1(int a, int b) {
	if (a > b) {
		swap(a, b);
	}
	int ans = (a + b) - (b - a) - 1;
	return ans;
}

int solve2(int a, int b) {
	int ans = 0;
	for (int c = 1; c < 300; c++) {
		if (a + b > c && a + c > b && c + b > a) {
			ans++;
		}
	}
	return ans;
}

signed main() {
	fast;

	while (true) {
		int a = rand() % 100 + 1, b = rand() % 100 + 1;
		if (solve1(a, b) != solve2(a, b)) {
			cout << a << " " << b << endl;
			cout << solve1(a, b) << " " << solve2(a, b) << endl;
			break;
		}
	}

}