﻿#include <iostream>
#include <vector>
#include <string.h>
#include <algorithm>
#include <math.h>
#include <set>

using namespace std;

set<int> ch;

vector<vector<vector<int>>> answer(71);

vector<vector<int>> f(int n, int mx) {
	if (n != 0) {
		answer[n] = {};
	}
	if (n == 0) {
		return answer[0];
	}
	vector<vector<int>> tek;
	for (int i = 1; i <= min(n, mx); i++) {
		if (ch.find(i) == ch.end()) {
			continue;
		}
		tek = f(n - i, i);
		for (int j = 0; j < tek.size(); j++) {
			tek[j].push_back(i);
		}
		for (int j = 0; j < tek.size(); j++) {
			answer[n].push_back(tek[j]);
		}
	}
	return answer[n];
}

int main() {
	answer[0] = { {} };
	int n;
	cin >> n;
	ch.insert(1);
	bool fff;
	for (int i = 3; i <= n; i++) {
		fff = false;
		for (int j = 2; j < i; j++) {
			if (i % j == 0) {
				fff = true;
				break;
			}
		}
		if (fff) {
			ch.insert(i);
		}
	}
	vector<vector<int>> ans = f(n, n);
	for (auto vec : ans) {
		for (int i = 0; i < vec.size(); i++) {
			if (i != 0) {
				cout << "+";
			}
			cout << vec[i];
		}
		cout << "\n";
	}
}