import java.util.*;

public class Main {

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);
        int n = s.nextInt();

        composite = new boolean[100];
        composite[1] = true;
        for (int x = 2; x < 100; x++) {
            if (composite[x]) continue;
            composite[x] = false;
            for (int y = 2 * x; y < 100; y += x) composite[y] = true;
        }

        List<String> res = res(n, 1);
        for (String r : res) System.out.println(r);
    }

    public static boolean[] composite = new boolean[100];
 
    public static List<String> res(int n, int min) {
        List<String> res = new ArrayList<>();
        if (n >= min && composite[n]) res.add(n + "");
        for (int m = min; m < n; m++) for (String s : res(n - m, m)) res.add(m + "+" + s);
        return res;
    }


}
