def cut_ropes(n, k, q, queries):
    ropes = [n]
    for i in range(k):
        longest_rope = ropes.pop(0)
        if longest_rope % 2 == 0:
            ropes.append(longest_rope // 2)
            ropes.append(longest_rope // 2)
        else:
            ropes.append(longest_rope // 2)
            ropes.append(longest_rope // 2 + 1)
    
    ropes.sort(reverse=True)
    result = []
    for query in queries:
        result.append(ropes[query-1])
    
    return result

n = int(input())
k = int(input())
q = int(input())

queries = input().split()
queries = [int(query) for query in queries]

results = cut_ropes(n, k, q, queries)

print(" ".join(str(x) for x in results))
