def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return False
    return True

def generate_difficult_partitions(n, current_partition):
    if n == 0:
        print(current_partition)
        return

    for i in range(1, n + 1):
        if not is_prime(i):
            if not current_partition or i >= current_partition[-1]:
                generate_difficult_partitions(n - i, current_partition + [i])

def difficult_partitions(n):
    generate_difficult_partitions(n, [])

# Get input from the user
n = int(input("Введите число n: "))

# Generate and print difficult partitions

difficult_partitions(n)
