def factorize(n, factors):
    if n == 1:
        return [factors]
    
    results = []
    
    for i in range(2, int(n**0.5) + 1):
        if n % i == 0:
            results.extend(factorize(n // i, factors + [i]))
    
    results.extend(factorize(1, factors + [n]))
    
    return results

n = int(input())

results = factorize(n, [])
count = len(results)

print(count)
