def cut(length, cuts):
    ropes = [length]
    for _ in range(cuts):
        max_rope = max(ropes)
        ropes.remove(max_rope)
        if max_rope % 2 == 0:
            ropes.extend([max_rope // 2, max_rope // 2])
        else:
            ropes.extend([max_rope // 2, max_rope // 2 + 1])
    return sorted(ropes, reverse=True)

length = int(input())
cuts = int(input())
queries = int(input())

res = cut(length, cuts)
query = input()
query = list(map(int, query.split()))

output = []
for index in query:
    output.append(str(res[index - 1]))

print(" ".join(output))
