#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

#define ndl '\n'

int main()
{
    int n, k, q;

    int* queries = new int[q];

    std::cin >> n >> k >> q;

    for (int i = 0; i < q; ++i)
    {
        std::cin >> queries[i];
    }

    std::vector<int> ropes;
    ropes.push_back(n);

    for (int i = 0; i < k; ++i)
    {
        auto iter = std::max_element(ropes.begin(), ropes.end());

        if (*iter % 2 == 0)
        {
            *iter /= 2;
            ropes.insert(iter, *iter);
        }
        else
        {
            *iter /= 2;
            ropes.insert(iter, *iter + 1);
        }
    }

    std::sort(ropes.begin(), ropes.end(), [](int a, int b)
              {
                  return a > b;
              });

    for (int i = 0; i < q; ++i)
    {
        std::cout << ropes[queries[i]-1] << ndl;
    }


    delete[] queries;

    return 0;
}
