﻿#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
#define ll long long

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll L, R, a;
	int n;
	cin >> L >> R >> n;
	vector<ll> pref(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> a;
		pref[i] = a + pref[i - 1];
	}

	ll now = 0;
	int l = 0;

	for (int i = 0; i <= n; i++) {
		while (pref[i] - pref[l] > R)
			l++;
		if (L <= pref[i] - pref[l] && pref[i] - pref[l] <= R) {
			cout << pref[l] << " " << pref[i];
			return 0;
		}
	}

	cout << -1 << ' ' << -1;
}
