﻿#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
#define ll long long

const int maxn = 71;

vector<int> now;
vector<int> mark(maxn);

void f(int x, int last) {
	//cout << x << "\n";
	if (x == 0) {
		cout << now[0];
		for (int i = 1; i < now.size(); i++) {
			cout << "+" << now[i];
		}
		cout << "\n";
		return;
	}

	for (int i = last; i < maxn; i++) {
		if (x >= i && mark[i]) {
			now.push_back(i);
			f(x - i, i);
			now.pop_back();
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	mark[1] = 1;
	for (int i = 4; i < maxn; i++) {
		for (int j = 2; j * j <= i; j++) {
			if (i % j == 0) {
				mark[i] = 1;
				//cout << "check: " << i << "\n";
				break;
			}
		}
	}
	int n;
	cin >> n;
	f(n, 0);
}
