from collections import deque

n = int(input())
k = int(input())
input()

ropes = deque([n])


for _ in range(k):
    mx = ropes.popleft()
    a = mx // 2
    b = mx - a

    if len(ropes) > 0:
        prev = ropes.pop()
        ropes.append(max(prev, b))
        ropes.append(min(prev, b))
        ropes.append(a)
    else:
        ropes.append(b)
        ropes.append(a)

ropes_list = list(ropes)

queries = map(int, input().split())

for query in queries:
    print(ropes_list[query - 1], end=' ')
