﻿#include <iostream>
#include <vector>

using namespace std;

#pragma GCC optimize("Ofast, unroll-loops")
#pragma target("avx2")


int main() {
	long long ll, rr;
	int n;

	cin >> ll >> rr >> n;

	vector<long long> arr(n);
	vector<long long> prefix(n);

	for (int i = 0; i < n; i++)
	{
		cin >> arr[i];
		if (i == 0) {
			prefix[0] = arr[0];
		}
		else {
			prefix[i] = arr[i] + prefix[i-1]; 
		}
	}

	int l = 0, r = 0;

	while (!(l == r == n - 1)) {
		if (prefix[r] - prefix[l] < ll) {
			r++;
		}
		else if(prefix[r] - prefix[l] > rr)
		{
			l++;
		}
		else {
			cout << prefix[l] << " " << prefix[r];
			break;
		}
	}
}
