// C

#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <fstream>

using namespace std;

int main() {
  //ifstream in("in C.txt");

  int64_t L, R;
  int N;
  
  cin >> L >> R;                       
  cin >> N;
  
  vector<int> D(N);
  for (int i = 0; i < N; i++) {
    cin >> D[i];
  }

  vector<int> psum(N, 0);
  psum[0] = D[0];
  for (int i = 1; i < N; i++) {
    psum[i] = psum[i - 1] + D[i];
  }


  int Xmin = -1, Xmax = -1;
  vector<int> Vmin(N), Vmax(N);

  for (int i = 0; i < N; i++) {
    Xmin = -1, Xmax = -1;
    for (int k = 0; k < N; k++) {
      if (psum[i + k] >= R && Xmin == -1) {
        Xmin = k + i;
      }

      if (psum[i + k] >= R + L && Xmax == -1) {
        Xmax = k + i;
      }                           

      if (Xmax != -1 && Xmin != -1) {
        Vmin[i] = Xmin;
        Vmax[i] = Xmax;
        break;
      }
    }
  }

  //for (int i = 0; i < N; i++) {
   // cout << Vmin[i] << ' ' << Vmax[i] << '\n';
  //}


  for (int i = 0; i < N; i++) {
    if (psum[Vmin[i]] + L <= psum[Vmax[i]]) {
      cout << psum[Vmin[i] - 1] << ' ' << psum[Vmax[i] - 1] << '\n';
    }
    break;
  }
  
  return 0;
}