#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

vector<int> ne_prost = {1}, pref;

void show_ans(int n, int pred) {
	if (n == 0) {
		for (int i = 0; i < pref.size() - 1; i++) {
			cout << pref[i] << '+';
		}
		cout << pref[pref.size() - 1] << '\n';
		return;
	}
	int ind = pred;
	while (ne_prost[ind] <= n) {
		pref.push_back(ne_prost[ind]);
		show_ans(n - ne_prost[ind], ind);
		pref.pop_back();
		ind++;
	}
}

int main() {
	long long n;
	cin >> n;
	for (int i = 1; i < 73; i++) {
		for (int j = 2; j < i; j++) {
			if (i % j == 0 && ne_prost[ne_prost.size() - 1] != i) ne_prost.push_back(i);
		}
	}
	show_ans(n, 0);
}