#include <iostream>
#include <vector>
using namespace std;

int pow(int x, int step) {
    if (step == 0)
        return 1;
    if (step % 2 == 1)
        return pow(x, step - 1) * x;
    else
        return pow(x * x, step / 2);
}

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    long long n;
    cin >> n;
    long long del = 2;
    while (n % del != 0) {
        del++;
    }
    long long step = del;
    int k = 0;
    while (n % step == 0) {
        step *= del;
        k += 1;
    }
    if (k == 3) {
        cout << 30;
        return 0;
    }
    cout << pow(2, 2 * k - 1);
}