#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <iterator>
#include <bitset>
#include <cstdlib>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <random>

using namespace std;

long long actions;

vector<pair<long long, long long>> rec(long long type1, long long amount1, long long type2, long long amount2) {
//    cout << type1 << " " << amount1 << "   " << type2 << " " << amount2 << "       " << actions << '\n';
//    if (actions == 0) {
//        vector<pair<long long, long long>> res = {make_pair(type1, amount1), make_pair(type2, amount2)};
//        sort(res.begin(), res.end());
//        return res;
//    }
    if (actions < amount1 + amount2) {
        if (amount2 >= actions) {
            if (type2 % 2 == 0) {
                long long type3 = type2 / 2;
                long long amount3 = 2 * actions;
                amount2 -= actions;
                vector<pair<long long, long long>> res;
                if (amount1 > 0) {
                    res.push_back(make_pair(type1, amount1));
                }
                if (amount2 > 0) {
                    res.push_back(make_pair(type2, amount2));
                }
                if (amount3 > 0) {
                    res.push_back(make_pair(type3, amount3));
                }
                sort(res.begin(), res.end());
                return res;
            } else {
                long long type3 = (type2 + 1) / 2;
                long long amount3 = actions;
                long long type4 = (type2 - 1) / 2;
                long long amount4 = actions;
                amount2 -= actions;
                vector<pair<long long, long long>> res;
                if (amount1 > 0) {
                    res.push_back(make_pair(type1, amount1));
                }
                if (amount2 > 0) {
                    res.push_back(make_pair(type2, amount2));
                }
                if (amount3 > 0) {
                    res.push_back(make_pair(type3, amount3));
                }
                if (amount4 > 0) {
                    res.push_back(make_pair(type4, amount4));
                }
                sort(res.begin(), res.end());
                return res;
            }
        } else {
            long long type3 = (type2 + 1) / 2;
            long long amount3 = amount2;
            long long type4 = (type2 - 1) / 2;
            long long amount4 = amount2;
            long long type5 = (type1 + (type1 & 1)) / 2;
            long long amount5 = actions - amount2;
            long long type6 = (type1 - (type1 & 1)) / 2;
            long long amount6 = actions - amount2;
            vector<pair<long long, long long>> res;
            if (amount1 - actions + amount2 > 0) {
                res.push_back(make_pair(type1, amount1 - actions + amount2));
            }
            if (amount5 > 0) {
                res.push_back(make_pair(type5, amount5));
            }
            if (amount6 > 0) {
                res.push_back(make_pair(type6, amount6));
            }
            if (amount3 > 0) {
                res.push_back(make_pair(type3, amount3));
            }
            if (amount4 > 0) {
                res.push_back(make_pair(type4, amount4));
            }
            sort(res.begin(), res.end());
            return res;
        }
    }
    long long type11, type22;
    actions -= amount1 + amount2;
    if ((type1 & 1) && amount1 != 0) {
        type11 = (type1 + 1) / 2;
        type22 = (type1 - 1) / 2;
    } else if ((type2 & 1) && amount2 != 0) {
        type11 = (type2 + 1) / 2;
        type22 = (type2 - 1) / 2;
    } else {
        type11 = (type1) / 2;
        type22 = (type1) / 2;
    }
//    cout << "type11: " << type11 << "    type22: " << type22 << '\n';
    long long amount11 = 0, amount22 = 0;
    if (type1 & 1) {
        if ((type1 + (type1 & 1)) / 2 == type11 || (type1 - (type1 & 1)) / 2 == type11) {
            amount11 += amount1;
        }
        if ((type1 + (type1 & 1)) / 2 == type22 || (type1 - (type1 & 1)) / 2 == type22) {
            amount22 += amount1;
        }
    } else {
        if (type11 == type1 / 2) {
            amount11 += 2 * amount1;
        } else {
            amount22 += 2 * amount1;
        }
    }
    if (type2 & 1) {
        if ((type2 + (type2 & 1)) / 2 == type11 || (type2 - (type2 & 1)) / 2 == type11) {
            amount11 += amount2;
        }
        if ((type2 + (type2 & 1)) / 2 == type22 || (type2 - (type2 & 1)) / 2 == type22) {
            amount22 += amount2;
        }
    } else {
        if (type11 == type2 / 2) {
            amount11 += 2 * amount2;
        } else {
            amount22 += 2 * amount2;
        }
    }
    if (type11 > type22) {
        return rec(type22, amount22, type11, amount11);
    }
    return rec(type11, amount11, type22, amount22);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    long long n, q;
    cin >> n >> actions >> q;
    vector<long long> a(q);
    for (auto &i : a) {
        cin >> i;
    }
    vector<pair<long long, long long>> ans = rec(n, 1, n, 0);
//    for (auto i : ans) {
//        cout << i.first << " " << i.second << '\n';
//    }
    for (auto i : a) {
        for (long long j = ans.size() - 1; j >= 0 && i > 0; j--) {
            if (ans[j].second >= i) {
                cout << ans[j].first;
                i = -1;
            } else {
                i -= ans[j].second;
            }
        }
        cout << " ";
    }
    return 0;
}