from math import sqrt

def is_prime(p):
    if p == 1:
        return p
    for i in range(2, int(sqrt(p)) + 2):
        if p % i == 0 and p != i:
            return i
    return p


def primes(n):
    p1, p2 = 0, 0
    for i in range(2, n // 2 + 1):
        if n % i == 0:
            if p1 == 0:
                p1 = i
                break
    while True:
        if(n % p1 == 0):
            n //= p1
        else:
            break
    return p1 * is_prime(n)

def num(x, m, nx):
    if x == 1 and nx > 1:
        return 1
    q = 0
    for i in range(m, x + 1):
        if(x % i == 0):
            q += num(x // i, i, nx + 1)
    return q

n = int(input())
r = primes(n)
k = 0
if k >= 10:
    return
while n > 1:
    n //= r
    k += 1
print(num(6 ** k, 2, 0))