#include <iostream>
#include <vector>
#include <stdint.h>
using namespace std;

int main()
{
	//Read L and R
	uint64_t l, r;
	cin >> l >> r;

	//Read N
	uint32_t n;
	cin >> n;

	//Read vector
	vector<uint64_t> d(n);
	for (uint32_t i = 0; i < n; i++)
	{
		cin >> d[i];
	}

	uint32_t sum = 0;
	uint32_t start = 0;
	uint32_t end = 0;

	bool is_find = false;

	for (uint32_t i = 0; i < n; i++)
	{
		sum = 0;
		for (uint32_t j = i; j < n; j++)
		{
			sum += d[j];

			if (sum >= l && sum <= r)
			{
				end = j;
				is_find = true;
				break;
			}

			if (sum >= r)
			{
				break;
			}
		}

		if (is_find)
		{
			start = i;
			break;
		}
	}

	if (!is_find)
	{
		cout << -1 << " " << -1;
	}
	else
	{
		sum = 0;
		for (uint32_t i = 0; i < start; i++)
		{
			sum += d[i];
		}

		cout << sum << " ";

		sum = 0;
		for (uint32_t i = 0; i <= end; i++)
		{
			sum += d[i];
		}

		cout << sum;
	}

	return 0;
}