def is_prime(num):
    primes = [2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67]
    return num in primes


paths = []


def recurse(num, path):
    global paths

    needed_sum = num - sum(path)

    if needed_sum == 0:
        path.sort()
        if path not in paths:
            paths.append(path)
            print("+".join([str(i) for i in path]))
        return None
    
    for i in range(1, needed_sum + 1):
        if is_prime(i):
            continue
        
        new_path = path[:] + [i]

        recurse(num, new_path)


n = int(input())

recurse(n, [])
