#include <iostream>
#include <algorithm>
#include <vector>

void cutRope(std::vector<int>& rope) {
    std::sort(rope.begin(), rope.end(), std::greater<int>());

    std::vector<int> newRope;
    for (size_t i = 0; i < rope.size(); ++i) {
        int len = rope[i];
        if (len % 2 == 0) {
            newRope.push_back(len / 2);
            newRope.push_back(len / 2);
        } else {
            newRope.push_back(len / 2);
            newRope.push_back(len / 2 + 1);
        }
    }

    rope = newRope;
}

int main() {
    int n, k;
    std::cin >> n >> k;

    std::vector<int> rope = {n};

    for (int i = 0; i < k; ++i) {
        cutRope(rope);
    }

    int q;
    std::cin >> q;

    for (int i = 0; i < q; ++i) {
        int idx;
        std::cin >> idx;
        std::cout << rope[idx] << " ";
    }

    return 0;
}
