import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Arrays;

public class Main4 {
    private static BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));

    public static void main(String[] args) throws Exception {
        long[] lAndR= readArLong(2);
        long l = lAndR[0];
        long r = lAndR[1];
        int n = readInt();
        int[] trees = readAr(n);
        long[] prefSum = new long[n+1];
        prefSum[0] = 0;
        prefSum[1] = trees[0];
        for (int i = 2; i < n+1; i++) {
            prefSum[i] = prefSum[i-1] + trees[i-1];
        }
        int s = 0;
        int e = 0;
        long curSum = 0;

        for (int i = 0; i < prefSum.length; i++) {
            if(curSum >= l && curSum <= r)
                break;
            if(curSum < l) {
                e++;
                curSum = prefSum[e] - prefSum[s];
            } else if(curSum > r) {
                s++;
                curSum = prefSum[e] - prefSum[s];
            }
        }

        if(!(curSum >= l && curSum <= r))
            System.out.println("-1 -1");
        else
            System.out.println(prefSum[s] + " " + prefSum[e]);
    //    System.out.println(Arrays.toString(prefSum));

    }

    private static String readString() throws Exception {
        return reader.readLine();
    }

    private static int readInt() throws Exception {
        return Integer.parseInt(reader.readLine());
    }

    private static int[] readAr(int len) throws Exception {
        String[] intsStr = readString().split(" ");
        int[] ints = new int[len];
        for (int i = 0; i < len; i++) {
            ints[i] = Integer.parseInt(intsStr[i]);
        }

        return ints;
    }

    private static long[] readArLong(int len) throws Exception {
        String[] intsStr = readString().split(" ");
        long[] ints = new long[len];
        for (int i = 0; i < len; i++) {
            ints[i] = Long.parseLong(intsStr[i]);
        }

        return ints;
    }
}
