import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.*;

public class Main5 {
    private static BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));

    public static void main(String[] args) throws Exception {
        long n = readLong();
        long k = readLong();
        int q =readInt();
        int[] queries = readAr(q);
        List<Long> res = new ArrayList<>();
        Queue<Long> queue = new PriorityQueue<>(Comparator.comparingLong(x -> x));
        for (int i = 0; i < k; i++) {
            long max;
            long second;
            if(n % 2 == 1) {
                max = n/2 + 1;
                second = n/2;
            } else {
                max = n/2;
                second = max;
            }
            Long l = queue.peek();
            if(l == null)
                n = max;
            else
                n = Math.max(l, max);

            if(n == max) {
                res.add(second);
                queue.add(second);
            } else {
                res.remove(n);
                res.add(second);
                res.add(max);
                queue.add(second);
                queue.add(max);
            }
            if(i == k-1)
              res.add(n);
        }

        res.sort(Comparator.reverseOrder());
        StringBuilder builder = new StringBuilder();
        for (int i = 0; i < q; i++) {
            long resByQuery = res.get(queries[i]-1);
            builder.append(resByQuery);
            if(i != q-1)
                builder.append(' ');
        }

        System.out.println(builder.toString());
    }

    private static int ceilLog2(long n) {
        int c = 0;
        while (n >= 2) {
            n /=2;
            c++;
        }

        return c;
    }

    private static String readString() throws Exception {
        return reader.readLine();
    }

    private static int readInt() throws Exception {
        return Integer.parseInt(reader.readLine());
    }

    private static long readLong() throws Exception {
        return Long.parseLong(reader.readLine());
    }

    private static int[] readAr(int len) throws Exception {
        String[] intsStr = readString().split(" ");
        int[] ints = new int[len];
        for (int i = 0; i < len; i++) {
            ints[i] = Integer.parseInt(intsStr[i]);
        }

        return ints;
    }
}
