def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return False
    return True

def non_prime_partitions(n):
    def helper(n, max_term, current_partition):
        if n == 0:
            print('+'.join(map(str, current_partition)))
            return
        for i in range(1, min(n, max_term) + 1):
            if not is_prime(i):
                helper(n - i, i, current_partition + [i])

    helper(n, n, [])

n = int(input())

non_prime_partitions(n)
