﻿#include <iostream>
#include <vector>

int bin_search(std::vector<long long>& v, int i, long long l, long long r) {
    int a = i, b = v.size() - 1; int mid, curr = -1;
    while (a < b) {
        mid = (a + b) / 2;
        if (v[mid] - v[i] >= l && v[mid] - v[i] <= r) {
            curr = mid;
            b = mid - 1;
            continue;
        }
        if (v[mid] - v[i] < l) {
            a = mid + 1;
            continue;
        }
        if (v[mid] - v[i] > r) {
            b = mid - 1;
            continue;
        }
    }
    if (a == b) {
        if (v[a] - v[i] >= l && v[a] - v[i] <= r)
            return a;
    }
    return curr;
}

int main()
{
    long long l, r;
    std::cin >> l >> r;
    int n;
    std::cin >> n;
    std::vector<long long> v(n + 1);
    long long a;
    std::cin >> a;
    v[0] = 0;
    v[1] = a;
    if (n == 1) {
        if (n >= r && n <= r) {
            std::cout << 0 << ' ' << n;
            return 0;
        }
        else
            std::cout << -1 << ' ' << -1;
        return 0;
    }
    for (int i = 2; i < n; ++i) {
        std::cin >> a;
        v[i] = v[i - 1] + a;
    }
    for (int i = 0; i < v.size(); ++i) {
        a = bin_search(v, i, l, r);
        if (a != -1) {
            std::cout << v[i] << ' ' << v[a];
            return 0;
        }
    }
    std::cout << -1 << ' ' << -1;
    return 0;
}