#include <bits/stdc++.h>

using namespace std;
#define int long long
using ll = long long;
using pii = pair<int, int>;

#ifdef LOCAL
#define DEBUG(...) {__VA_ARGS__}
#else
#define DEBUG(...)
#endif

#define ENDL "\n"
#define ALL(x) (x).begin(), (x).end()
#define forn(i, s, f) for (int i = (s); i < (f); ++i)
#define rofn(i, s, f) for (int i = (s); i >= (f); --i)

void solve() {
    int L, R;
    cin >> L >> R;
    int n;
    cin >> n;
    vector<int> d(n);
    forn(i, 0, n) cin >> d[i];
    vector<int> p(n + 1);
    forn(i, 1, n + 1) {
        p[i] = p[i - 1] + d[i - 1];
    }
    int i = 0, j = 0, curlen = 0;
    while (j < n) {
        curlen += d[j];
        if (L < curlen and curlen < R) {
            cout << p[i] << ' ' << p[j + 1] << ENDL;
            return;
        }
        while (i < n and curlen > R) {
            curlen -= d[i];
            ++i;
        }
        ++j;
    }
    cout << -1 << ' ' << -1 << ENDL;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int testNum = 1;
//    cin >> testNum;
    forn(i, 0, testNum) {
        solve();
    }
    return 0;
}
