#include <bits/stdc++.h>

using namespace std;
#define int long long
using ll = long long;
using pii = pair<int, int>;

#ifdef LOCAL
#define DEBUG(...) {__VA_ARGS__}
#else
#define DEBUG(...)
#endif

#define ENDL "\n"
#define ALL(x) (x).begin(), (x).end()
#define forn(i, s, f) for (int i = (s); i < (f); ++i)
#define rofn(i, s, f) for (int i = (s); i >= (f); --i)

bool prime1(int num) {
    if (num == 1) {
        return false;
    }
    int i = 2;
    while (i * i <= num) {
        if (num % i == 0) return false;
        ++i;
    }
    return true;
}

void gen(int n, int pr, vector<int> &cur) {
    if (n == 0) {
        forn(i, 0, cur.size()) {
            cout << cur[i];
            if (i != cur.size() - 1) {
                cout << "+";
            } else {
                cout << ENDL;
            }
        }
        return;
    }
    forn(i, pr, n + 1) {
        if (!prime1(i)) {
            cur.push_back(i);
            gen(n - i, i, cur);
            cur.pop_back();
        }
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> cur;
    gen(n, 1, cur);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int testNum = 1;
//    cin >> testNum;
    forn(i, 0, testNum) {
        solve();
    }
    return 0;
}
