#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

/* ~~~~~ useful definitions ~~~~~ */
#define all(x) x.begin(), x.end()
#define mp make_pair
#define sz(x) (ll) x.size()
#define endl "\n"

/* ~~~~~ debug ~~~~~ */
#define printv(V) for (auto I : V) {cout << I << " ";} cout << endl;
#define debv(V) for (auto I : V) {cerr << I << " ";} cerr << endl;
#define deb(V) cerr << #V << " " << V << endl;
#define print2v(W) for (auto V : W) {printv(V)}

using namespace std;

/* ~~~~~ type definitions ~~~~~ */
using ll = long long;
using ld = long double;

/* ~~~~~ constants ~~~~~ */
const int INF = INT32_MAX;
const ll INFLL = INT64_MAX;
const ld EPS = 1e-6;
const ll MOD = 998244353;
const ld Pi = 3.141592653589793238462643383279;

/* ~~~~~~~~~~~~~~~ solution ~~~~~~~~~~~~~~~ */
#define int long long

int n;


signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
    auto start_time = clock();
    cerr << setprecision(6) << fixed;
    cout << setprecision(12) << fixed;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(16) << fixed;
#endif

    cin >> n;
    int c = 0;
    int cn = n;
    int k;
    cin >> k;
    map<int, int> numb= {{n, 1}};
    set<int> num = {n};
    while (k != 0) {
        int f = *num.rbegin();
        if(k - numb[f] < 0) {
            numb[f] -= k;
            numb[(f + 1) / 2] += k;
            numb[f / 2] += k;
            num.insert((f + 1) / 2);
            num.insert(f / 2);
            k = 0;
        } else {
            numb[(f + 1) / 2] += numb[f];
            numb[f / 2] += numb[f];
            k -= numb[f];
            numb[f] = 0;
            num.insert((f + 1) / 2);
            num.insert(f / 2);
            num.erase(f);
        }
    }
    vector<int> a;
    for (auto x : num) {
        a.push_back(x);
    }
    reverse(all(a));
//    cout << sz(a);
//    printv(a);
    int t;
    cin >> t;
    while (t--) {
        int q;
        cin >> q;
        int ans = -1;
        int cur = 0;
        while (q > cur) {
            ans++;
            cur += numb[a[ans]];
        }
        cout << a[ans] << " ";
    }

#ifdef LOCAL
    auto end_time = clock();
    cerr << "Execution time: " << (end_time - start_time) * (int) 1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}