def cut_rope(n, k, q, queries):
    ropes = [n]
    for _ in range(k):
        x = max(ropes)
        ropes.remove(x)
        if x % 2 == 0:
            ropes.extend([x // 2, x // 2])
        else:
            ropes.extend([x // 2, x // 2 + 1])
    sorted_ropes = sorted(ropes, reverse=True)
    results = []
    for query in queries:
        results.append(sorted_ropes[query - 1])
    return results
n = int(input())
k = int(input())
q = int(input())
queries = list(map(int, input().split()))
results = cut_rope(n, k, q, queries)
for result in results:
    print(result)
