#include <iostream>
#include <cmath>
#include <vector>

using namespace std;

bool isPrime (int a) {
    if (a == 0 || a == 1 || a == 2) {
        return true;
    }
    for (int i = 2; i < sqrt(a) + 1; i++) {
        if(a % i == 0) {
            return false;
        }
    }
    return true;
}

void vecOut(vector<int> arr) {
    for(size_t i = 0; i < arr.size(); i++) {
        if(i != arr.size() - 1) {
            cout << arr[i] << "+";
        } else {
            cout << arr[i];
        }
    }
    cout << endl;
}

int check(vector<int> arr, int from) {
    int sum = 0;
    for(int i = from; i >= 0; i--) {
        sum += arr[i];
        if(!isPrime(sum) && i != from) {
            return i;
        }
    }
    return -1;
}

vector<int> sokr(vector<int> arr, int from, int to) {
    vector<int> res;
    for(int i = 0; i < from; i++) {
        res.push_back(arr[i]);
    }
    int sum = 0;
    for(int i = from; i <= to; i++) {
        sum += arr[i];
    }
    res.push_back(sum);
    for(int i = to + 1; i < arr.size(); i++) {
        res.push_back(arr[i]);
    }
    return res;
}


int main() {
    int n;
    cin >> n;
    vector<int> razl(n, 1);
    vecOut(razl);

    int new_size = n;

    while(1) {
    int to = razl.size() - 1;
    int ck = check(razl, to);
        if(ck != -1) {
            razl = sokr(razl, ck, to);
            vecOut(razl);
        } else {
            break;
        }
    }


}
