﻿#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int l, r; cin >> l >> r;
    int n; cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }

    vector<int> pref(n + 1);
    for (int i = 1; i <= n; ++i) {
        pref[i] = pref[i - 1] + v[i - 1];
    }


    int left = 0, right = 1;
    vector<pair<int, int>> ans;
    while (right < n) {
        if (pref[right] - pref[left] < l) {
            ++right;
        }
        else if (pref[right] - pref[left] >= l && pref[right] - pref[left] <= r) {
            ans.push_back({ pref[right], pref[left] });
            ++left;
        }
        else if (pref[right] - pref[left] > r) {
            ++left;
        }
       
    }

    sort(ans.begin(), ans.end(), [](pair<int, int> &l, pair<int, int> &r) {
        if (l.second == r.second) return l.first < r.first;
        else return l.second < r.second;
        });

    cout << ans[0].second << " " << ans[0].first;
    return 0;
}

