def generate_compositions(n):
    if n == 0:
        return [([], True)]
    else:
        result = []
        for k in range(1, n // 2 + 1):
            prefix, is_prime = generate_compositions(n - k)
            for i in range(len(prefix)):
                suffix = prefix[:i] + [k] + prefix[i:]
                result.append((suffix, is_prime and k > 1))
        return result

n = int(input())
result = generate_compositions(n)
for composition, is_prime in result:
    print(composition)
    if not is_prime:
        print('not prime')