import random


def quicksort(nums, fst, lst):
    if fst >= lst: return

    i, j = fst, lst
    pivot = nums[random.randint(fst, lst)]

    while i <= j:
        while nums[i] < pivot: i += 1
        while nums[j] > pivot: j -= 1
        if i <= j:
            nums[i], nums[j] = nums[j], nums[i]
            i, j = i + 1, j - 1
    quicksort(nums, fst, j)
    quicksort(nums, i, lst)
    return nums


n = [int(i) for i in input().split()]
k = int(input())
a = int(input())
q = [int(a) for a in input().split()]

for i in range(k):
    n.append(n[0] // 2)
    n[0] = n[0] // 2 + (n[0] % 2)
    n = quicksort(n, 0, len(n) - 1)
    n = n[::-1]

for i in range(a):
    print(n[q[i] - 1], end=' ')