#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <cmath>
#include <random>
#include <string>
#include <climits>

using namespace std;
using ll = long long;
using ull = unsigned long long;

const ll INF = 1e15;

int main() {
    ios::sync_with_stdio(false);
    ll l, r, n;
    cin >> l >> r >> n;
    vector<ll> ls(n + 1, 0);
    for (ll i = 1; i <= n; i++) {
        cin >> ls[i];
    }
    ll i = 0, j = 0;
    ll s = 0;
    ll start = 0;
    pair<ll, ll> ans  = make_pair(0, INF);
    while (j < n) {
        j++;
        s += ls[j];
        if (s >= l && s <= r) {
            if ((s + start) <= ans.second) {
                if (((s + start) == ans.second && start < ans.first) || (s + start) < ans.second) {
                    ans = make_pair(start, s + start);
                }
            }
        }
        if (s > r) {
            i++;
            j = i;
            s = 0;
            start += ls[i];
        }
    }
    if (ans.second == INF) {
        cout << -1 << " " << -1;
    } else {
        cout << ans.first << " " << ans.second;
    }
}