#include <iostream>
#include <string>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>

using ll = long long;
using ld = long double;

using namespace std;

const ll inf = 1e18;

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    ll n, k;
    cin >> n >> k;

    int st = 0;
    ll two = 1;
    while (two - 1 <= k) {
        ++st;
        two *= 2;
    }
    --st;
    two /= 2;

    ll left = n / two;
    vector<ll> cnt;
    vector<ll> nbr;
    if (left * two != n) {
        cnt = {(two) / 2, (two) / 2, 0, 0};
        ++left;
        ll half = left / 2;
        nbr = {left, left-1, left - half, half};
        k -= (two - 1);
        ll iter = min(cnt[0], k);

        cnt[0] -= iter;
        cnt[2] = iter;
        cnt[3] = iter;
        k -= iter;
        if (0 < k) {
            iter = min(cnt[1], k);
            cnt[0] -= iter;
            cnt[2] += iter;
            cnt[3] += iter;
        }
    } else {
        cnt = {(k + two - 1) / 2, 0, 0};
        ll half = left / 2;
        nbr = {left, left - half, half};
        k -= (two - 1);
        ll iter = min(cnt[0], k);

        cnt[0] -= iter;
        cnt[1] = iter;
        if (left % 2 == 0) {
            cnt[1] += iter;
        } else {
            cnt[2] = iter;
        }
        k -= iter;
        if (0 < k) {
            iter = min(cnt[1], k);
            cnt[0] -= iter;
            cnt[1] += iter;
            if (left % 2 == 0) {
                cnt[1] += iter;
            } else {
                cnt[2] += iter;
            }
        }
    }

    int q;
    cin >> q;
    for (int it = 0, t; it<q; ++it) {
        cin >> t;
        for (int i =0; i<4; ++i) {
            t -= cnt[i];
            if (t <= 0) {
                cout << nbr[i] << ' ';
                break;
            }
        }
    }
    cout << "\n";
}
