﻿#include <iostream>
#include <vector>
using namespace std;

int main() {
    long long l, r, n;
    cin >> l >> r >> n;
    vector<long long> dist(n + 1);
    dist[0] = 0;
    for (long long i = 1; i < n + 1; i++) {
        cin >> dist[i];
        dist[i] += dist[i - 1];
    }
    vector<long long> lr(r - l + 1);
    for (long long i = 0; i < r - l + 1; i++) {
        lr[i] = l + i;
    }
    for (long long i = 1; i < n + 1; i++) {
        for (long long j = 0; j < i; j++) {
            for (long long a = 0; a < r - l + 1; a++) {
                if (dist[i] - dist[j] == lr[a]) {
                    cout << dist[j] << " " << dist[i];
                    return 0;
                }
            }
        }
    }
    cout << "-1 -1";
    return 0;
}
/*
100 120
7
45 45 45 35 30 35 45
*/