#define _GLIBCXX_DEBUG
#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
template<typename T>
istream& operator>>(istream&in, vector<T>&a){
    for (auto &i:a)in>>i;
    return in;
}
template<typename T>
ostream& operator<<(ostream&in, vector<T>&a){
    for (auto &i:a)in<<i<<'\n';
    return in;
}
template<typename T>
ostream& operator<<(ostream&out, vector<vector<T>>&a){
    for (auto &i:a)out<<i<<'\n';
    return out;
}
struct Test{
    int n;
    ll ql;
    ll qr;
    vector<ll>a;
    vector<ll>p;
    Test(){
        cin>>ql>>qr>>n;
        a.resize(n);
        cin>>a;
        p.resize(n+1,0);
        for (int i=0;i<n;i++){
            p[i+1]=p[i]+a[i];
        }
    }
    ll get (int l, int r){
        return p[r]-p[l];
    }
    bool ok(int l, int r){
    return get(l,r)>=ql && get(l,r)<=qr;
    }
    void out(int l, int r){
        cout<<get(0,l)<<' '<<get(0,r)<<'\n';
        exit(0);
    }
    void work(){
        for (int r=0; r<=n;r++){
            int tl=0;
            if (ok(tl,r))out(tl,r);
            if (get(tl,r)<ql)continue;
            int tr=r;
            while(tr-tl>1){
                int tm=(tr+tl)/2;
                if (get(tm,r)>=ql)tl=tm;
                else tr=tm;
            }
            if (!ok(tl,r))continue;
            tr=tl;
            tl=0;
            while (tr-tl>1){
                int tm=(tr+tl)/2;
                if (get(tm,r)<=qr)tr=tm;
                else tl=tm;
            }
            out(tr,r);
        }
        cout<<-1<<' '<<-1<<'\n';
    }
};
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    Test a;
    a.work();
}
