import sys

input = sys.stdin.readline

def solve():
    L, R = map(int, input().split())
    n = int(input())
    a = list(map(int, input().split()))
    d = [0] * (n + 1)
    for i in range(n):
        d[i + 1] = d[i] + a[i]
    for i in range(n):
        l = -1
        r = i
        while l + 1 != r:
            mid = (l + r) // 2
            if d[i] - d[mid] > R:
                l = mid
            else:
                r = mid
        if d[i] - d[r] >= L:
            print(d[r], d[i])
            return
    print(-1, -1)
            
    
    
solve()
